Package org.codehaus.groovy.vmplugin

# Interface VMPlugin

All Known Implementing Classes:
  `Java5`, `Java6`, `Java7`, `Java8`, `Java9`

    public interface VMPlugin

Interface to access VM version based actions. This interface is for internal use only!

- ## Method Summary

  Modifier and Type | Method | Description
  --- | --- | ---
  `boolean` | `checkAccessible​(java.lang.Class<?> callerClass, java.lang.Class<?> declaringClass, int memberModifiers, boolean allowIllegalAccess)` | check whether the member can be accessed or not
  `boolean` | `checkCanSetAccessible​(java.lang.reflect.AccessibleObject accessibleObject, java.lang.Class<?> callerClass)` | Check whether invoking `AccessibleObject.setAccessible(boolean)` on the accessible object will be completed successfully
  `void` | `configureAnnotation​(AnnotationNode an)` |
  `void` | `configureAnnotationNodeFromDefinition​(AnnotationNode definition, AnnotationNode root)` |
  `void` | `configureClassNode​(CompileUnit compileUnit, ClassNode classNode)` |
  `default java.util.Map<java.lang.String,​java.util.Set<java.lang.String>>` | `getDefaultImportClasses​(java.lang.String[] packageNames)` | Returns the default import classes: class name -> the relevant package names
  `java.lang.Object` | `getInvokeSpecialHandle​(java.lang.reflect.Method m, java.lang.Object receiver)` | Returns a handle with bound receiver to invokeSpecial the given method.
  `java.lang.Class[]` | `getPluginDefaultGroovyMethods()` |
  `java.lang.Class[]` | `getPluginStaticGroovyMethods()` |
  `int` | `getVersion()` | Gives the version the plugin is made for
  `void` | `invalidateCallSites()` |
  `java.lang.Object` | `invokeHandle​(java.lang.Object handle, java.lang.Object[] args)` | Invokes a handle produced by #getInvokeSpecialdHandle
  `void` | `setAdditionalClassInformation​(ClassNode c)` |
  `MetaMethod` | `transformMetaMethod​(MetaClass metaClass, MetaMethod metaMethod)` | transform meta method.
  `MetaMethod` | `transformMetaMethod​(MetaClass metaClass, MetaMethod metaMethod, java.lang.Class<?> caller)` | transform meta method
  `boolean` | `trySetAccessible​(java.lang.reflect.AccessibleObject ao)` | Set the `accessible` flag for this reflected object to `true` if possible.

- ## Method Details

  - ### setAdditionalClassInformation

    void setAdditionalClassInformation​(ClassNode c)

  - ### getPluginDefaultGroovyMethods

    java.lang.Class[] getPluginDefaultGroovyMethods()

  - ### getPluginStaticGroovyMethods

    java.lang.Class[] getPluginStaticGroovyMethods()

  - ### configureAnnotationNodeFromDefinition

    void configureAnnotationNodeFromDefinition​(AnnotationNode definition, AnnotationNode root)

  - ### configureAnnotation

    void configureAnnotation​(AnnotationNode an)

  - ### configureClassNode

    void configureClassNode​(CompileUnit compileUnit, ClassNode classNode)

  - ### invalidateCallSites

    void invalidateCallSites()

  - ### getInvokeSpecialHandle

    java.lang.Object getInvokeSpecialHandle​(java.lang.reflect.Method m, java.lang.Object receiver)
    Returns a handle with bound receiver to invokeSpecial the given method. This method will require at least Java 7, but since the source has to compile on older Java versions as well it is not marked to return a MethodHandle and uses Object instead
    Returns:
      null in case of jdk<7, otherwise a handle that takes the method call arguments for the invokespecial call

  - ### invokeHandle

    java.lang.Object invokeHandle​(java.lang.Object handle, java.lang.Object[] args) throws java.lang.Throwable
    Invokes a handle produced by #getInvokeSpecialdHandle
    Parameters:
      `handle` - the handle
      `args` - arguments for the method call, can be empty but not null
    Returns:
      the result of the method call
    Throws:
      `java.lang.Throwable`

  - ### getVersion

    int getVersion()
    Gives the version the plugin is made for
    Returns:
      7 for jdk7, 8 for jdk8, 9 for jdk9 or higher

  - ### checkCanSetAccessible

    boolean checkCanSetAccessible​(java.lang.reflect.AccessibleObject accessibleObject, java.lang.Class<?> callerClass)
    Check whether invoking `AccessibleObject.setAccessible(boolean)` on the accessible object will be completed successfully
    Parameters:
      `accessibleObject` - the accessible object to check
      `callerClass` - the callerClass to invoke `setAccessible`
    Returns:
      the check result

  - ### checkAccessible

    boolean checkAccessible​(java.lang.Class<?> callerClass, java.lang.Class<?> declaringClass, int memberModifiers, boolean allowIllegalAccess)
    check whether the member can be accessed or not
    Parameters:
      `callerClass` - callerClass the callerClass to invoke `setAccessible`
      `declaringClass` - the type of member owner
      `memberModifiers` - modifiers of member
      `allowIllegalAccess` - whether to allow illegal access
    Returns:
      the result of checking

  - ### trySetAccessible

    boolean trySetAccessible​(java.lang.reflect.AccessibleObject ao)
    Set the `accessible` flag for this reflected object to `true` if possible.
    Parameters:
      `ao` - the accessible object
    Returns:
      `true` if the `accessible` flag is set to `true`; `false` if access cannot be enabled.
    Throws:
      `java.lang.SecurityException` - if the request is denied by the security manager

  - ### transformMetaMethod

    MetaMethod transformMetaMethod​(MetaClass metaClass, MetaMethod metaMethod, java.lang.Class<?> caller)
    transform meta method
    Parameters:
      `metaClass` - meta class
      `metaMethod` - the original meta method
      `caller` - caller class, whose method sets accessible for methods
    Returns:
      the transformed meta method

  - ### transformMetaMethod

    MetaMethod transformMetaMethod​(MetaClass metaClass, MetaMethod metaMethod)
    transform meta method.
    Parameters:
      `metaClass` - meta class
      `metaMethod` - the original meta method
    Returns:
      the transformed meta method

  - ### getDefaultImportClasses

    default java.util.Map<java.lang.String,​java.util.Set<java.lang.String>> getDefaultImportClasses​(java.lang.String[] packageNames)
    Returns the default import classes: class name -> the relevant package names
    Parameters:
      `packageNames` - the default import package names, e.g. java.lang.
    Returns:
      the default import classes
    Since:
      3.0.2